package;

import hage.HGESprite;
import hage.HGE;

/**
 * ...
 * @author JanGamesCo
 */
class Block extends HGESprite
{
	private var health:Int;
	
	public function new(X:Float=0, Y:Float=0, Health:Int=1)
	{
		super(X, Y, Math.floor(HGE.width / 10), Math.floor(HGE.height / 30), 0, 1);
		
		setHealth(Health);
		
		color = getColor();
		
		Data.the.blocks.push(this);
	}
	
	public function setHealth(Health:Int):Void 
	{
		health = Math.floor(Math.min(Health, 8));
		color = getColor();
	}
	
	public function damage()
	{
		health -= 1;
		
		color = getColor();
		
		if (health < 1) {
			kill();
			
			//Add powerup
			if (Math.random() < Data.the.powerUpChance) {
				addPowerUp();
			}
		}
	}
	
	private function getColor():UInt
	{
		return 0xFF0000FF + 0x00202000 * (8 - health);
	}
	
	private function addPowerUp():Void
	{
		for (powup in Data.the.powerups) {
			if (powup.exists == false) {
				powup.reset();
				powup.x = x + (width - powup.width) / 2;
				powup.y = y + (height - powup.height) / 2;
				return;
			}
		}
		
		var powup:PowerUp = new PowerUp(x, y);
		powup.x += (width - powup.width) / 2;
		powup.y += (height - powup.height) / 2;
		HGE.game.add(powup);
	}
	
	override public function kill():Void 
	{
		super.kill();
		
		//Check level end
		var i:Int = 0;
		for (block in Data.the.blocks) {
			if (block.exists) { i++; }
		}
		
		if (i == 0) { Data.the.breakout.gameLevelUp(); }
	}
	
}