package;

import PowerUp.PowerUpType;

/**
 * ...
 * @author JanGames
 */
class Data
{
	/**Singleton reference*/
	public static var the:Data;
	
	/**Points and level counter*/
	public var points:Int;
	public var level:Int;

	/**Entities references*/
	public var paddle:Paddle;
	public var balls:Array<Ball>;
	public var blocks:Array<Block>;
	public var powerups:Array<PowerUp>;
	
	/**Power up Data*/
	public var powerUpsVals:Array<PowerUpType>;
	public var powerUpsWeights:Array<Float>;
	public var powerUpChance:Float;

	/**Breakout game reference*/
	public var breakout:Breakout;
	
	public function new()
	{
		reset();
		
		//Set reference
		the = this;
		
		//Create arrays
		paddle = null;
		balls = new Array();
		blocks = new Array();
		powerups = new Array();
		
		//Power up data
		powerUpsVals = [PowerUpType.FASTER, PowerUpType.SLOW, PowerUpType.LARGER, PowerUpType.SHORTER, 
			PowerUpType.LAZER, PowerUpType.MAGNET, PowerUpType.DOUBLE, PowerUpType.TRIPLE];
		powerUpsWeights = [1, 1, 0.5, 0.35, 0.1, 0.1, 0.05, 0.02];
		powerUpChance = 0.15;
	}
	
	//Reset data
	public function reset()
	{
		points = 0;
		level = 1;
	}
	
}