package;

import hage.HGE;
import hage.HGEBasic;
import hage.HGEPool;

/**
 * ...
 * @author JanGamesCo
 */
class LazerLauncher extends HGEPool
{
	public var x:Float;
	public var y:Float;
	
	private var cooldown:Float;
	private var timer:Float;

	public function new(X:Float, Y:Float)
	{
		super();
		
		x = X;
		y = Y;
		
		cooldown = 0.5;
		timer = 0;
	}
	
	override public function createChild()
	{
		var lazer:Lazer = new Lazer(x, y);
		add(lazer);
		return lazer;
	}
	
	override public function getDead():HGEBasic 
	{
		if(timer <= 0) {
			var lazer:Lazer = cast(super.getDead(), Lazer);
			lazer.revive();
			lazer.x = x - lazer.width / 2;
			lazer.y = y - lazer.height;
			
			timer = cooldown;
			
			return lazer;
		}
		return null;
	}
	
	override public function update():Void 
	{
		super.update();
		
		timer = Math.max(0, timer - HGE.delta);
		
		//Bounce on blocks
		for (lazer in childrens) {
			for (block in Data.the.blocks) {
				if (lazer.exists && cast(lazer, Lazer).aabb(block)) {
					trace("lalala");
					
					//Damage block
					block.damage();
					
					killChild(lazer);
				}
			}
		}
	}
	
}